/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : Cpu.C
**     Project   : _8037_exp
**     Processor : 56F8037
**     Component : 56F8037
**     Version   : Component 01.072, Driver 02.08, CPU db: 2.87.263
**     Datasheet : Blue_SS_Version_0_1
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 2010-09-18,  11:59
**     Abstract  :
**
**     Settings  :
**
**     Contents  :
**         EnableInt   - void Cpu_EnableInt(void);
**         DisableInt  - void Cpu_DisableInt(void);
**         SetWaitMode - void Cpu_SetWaitMode(void);
**         SetStopMode - void Cpu_SetStopMode(void);
**
**     (c) Freescale Semiconductor
**     2004 All Rights Reserved
**
**     Copyright : 1997 - 2009 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE Cpu. */
#include "SCI1.h"
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Events.h"
#include "Cpu.h"


/* Global variables */
volatile word SR_lock = 0;             /* Lock */
volatile word SR_reg;                  /* Current value of the SR register */
/*
** ===================================================================
**     Method      :  Cpu_Interrupt (component 56F8037)
**
**     Description :
**         The method services unhandled interrupt vectors.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
#pragma interrupt alignsp
void Cpu_Interrupt(void)
{
  asm(DEBUGHLT);                       /* Halt the core and placing it in the debug processing state */
}

/*
** ===================================================================
**     Method      :  Cpu_DisableInt (component 56F8037)
**
**     Description :
**         Disables all maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_DisableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_EnableInt (component 56F8037)
**
**     Description :
**         Enables all maskable interrupts
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_EnableInt(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_SetStopMode (component 56F8037)
**
**     Description :
**         Sets low power mode - Stop mode.
**         For more information about the stop mode see this CPU
**         documentation.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_SetStopMode(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  Cpu_SetWaitMode (component 56F8037)
**
**     Description :
**         Sets low power mode - Wait mode.
**         For more information about the wait mode see this CPU
**         documentation.
**         Release from wait mode: Reset or interrupt
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
/*
void Cpu_SetWaitMode(void)

**      This method is implemented as macro in the header module. **
*/

/*
** ===================================================================
**     Method      :  _EntryPoint (component 56F8037)
**
**     Description :
**         Initializes the whole system like timing and so on. At the end 
**         of this function, the C startup is invoked to initialize stack,
**         memory areas and so on.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
extern void init_56800_(void);         /* Forward declaration of external startup function declared in startup file */

/*** !!! Here you can place your own code using property "User data declarations" on the build options tab. !!! ***/

void _EntryPoint(void)
{
  #pragma constarray off

  /*** !!! Here you can place your own code before PE initialization using property "User code before PE initialization" on the build options tab. !!! ***/

  /*** ### 56F8037 "Cpu" init code ... ***/
  /*** PE initialization code after reset ***/
  /* System clock initialization */
  setRegBitGroup(OCCS_OCTRL, TRIM, (word)getReg(FM_OPT1)); /* Set the trim osc freq with factory programmed value */
  setRegBit(OCCS_OCTRL, CLK_MODE);     /* Select an internal oscillator mode */
  clrRegBit(OCCS_CTRL, PRECS);         /* Select an internal clock source for the CPU core */
  setReg(OCCS_CTRL, (OCCS_CTRL_LCKON_MASK | OCCS_CTRL_ZSRC0_MASK)); /* Enable PLL, LCKON and select clock source from prescaler */
  /* OCCS_DIVBY: LORTP=2,??=0,PLLCOD=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0 */
  setReg16(OCCS_DIVBY, 0x2000U);       /* Set the clock prescalers */ 
  while(!getRegBit(OCCS_STAT, LCK0)){} /* Wait for PLL lock */
  setReg(OCCS_CTRL, (OCCS_CTRL_LCKON_MASK | OCCS_CTRL_ZSRC1_MASK)); /* Select clock source from postscaler */
  /* FM_CLKDIV: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,DIVLD=0,PRDIV8=0,DIV=0x28 */
  setReg16(FM_CLKDIV, 0x28U);          /* Set the flash clock prescaler */ 
  /*** End of PE initialization code after reset ***/

  /*** !!! Here you can place your own code after PE initialization using property "User code after PE initialization" on the build options tab. !!! ***/

  setReg(COP_CTRL, 0);                 /* Disable COP running after reset */
  asm(JMP init_56800_);                /* Jump to C startup code */
}

/*
** ===================================================================
**     Method      :  PE_low_level_init (component 56F8037)
**
**     Description :
**         Initializes beans and provides common register initialization. 
**         The method is called automatically as a part of the 
**         application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_low_level_init(void)
{
  /* GPIO_A_DRIVE: ??=0,DRIVE=0 */
  setReg16(GPIO_A_DRIVE, 0x00U);       /* Set High/Low drive strength on GPIOA pins according to the CPU bean settings */ 
  /* GPIO_B_DRIVE: ??=0,??=0,DRIVE=0 */
  setReg16(GPIO_B_DRIVE, 0x00U);       /* Set High/Low drive strength on GPIOB pins according to the CPU bean settings */ 
  /* GPIO_C_DRIVE: DRIVE=0 */
  setReg16(GPIO_C_DRIVE, 0x00U);       /* Set High/Low drive strength on GPIOC pins according to the CPU bean settings */ 
  /* GPIO_D_DRIVE: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,DRIVE=0 */
  setReg16(GPIO_D_DRIVE, 0x00U);       /* Set High/Low drive strength on GPIOD pins according to the CPU bean settings */ 
  /* SIM_PCR: TMRB_CR=0,TMRA_CR=0,PWM_CR=0,I2C_CR=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0 */
  setReg16(SIM_PCR, 0x00U);            /* Set the TMRB; TMRA; PWM; I2C module clock rates */ 
  /* SIM_PCE0: CMPB=0,CMPA=0,DAC1=0,DAC0=0,??=0,ADC=0,??=0,??=0,??=0,I2C=0,QSCI1=1,QSCI0=0,QSPI1=0,QSPI0=0,??=0,PWM=0 */
  setReg16(SIM_PCE0, 0x20U);           /* Set up the peripheral clock enable register 0 */ 
  /* SIM_PCE1: ??=0,PIT2=0,PIT1=0,PIT0=0,??=0,??=0,??=0,??=0,TB3=0,TB2=0,TB1=0,TB0=0,TA3=0,TA2=0,TA1=0,TA0=0 */
  setReg16(SIM_PCE1, 0x00U);           /* Set up the peripheral clock enable register 1 */ 
  /* SIM_SD0: CMPB_SD=0,CMPA_SD=0,DAC1_SD=0,DAC0_SD=0,??=0,ADC_SD=0,??=0,??=0,??=0,I2C_SD=0,QSCI1_SD=0,QSCI0_SD=0,QSPI1_SD=0,QSPI0_SD=0,??=0,PWM_SD=0 */
  setReg16(SIM_SD0, 0x00U);            /* Set up the STOP disable register 0 */ 
  /* SIM_SD1: ??=0,PIT2_SD=0,PIT1_SD=0,PIT0_SD=0,??=0,??=0,??=0,??=0,TB3_SD=0,TB2_SD=0,TB1_SD=0,TB0_SD=0,TA3_SD=0,TA2_SD=0,TA1_SD=0,TA0_SD=0 */
  setReg16(SIM_SD1, 0x00U);            /* Set up the STOP disable register 1 */ 
  /* SIM_CTRL: ??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,??=0,ONCEEBL=0,SWRST=0,STOP_DISABLE=0,WAIT_DISABLE=0 */
  setReg16(SIM_CTRL, 0x00U);           /* Set up the SIM control register */ 
  /* SIM_CLKOUT: ??=0,??=0,??=0,??=0,??=0,??=0,PWM3_b=0,PWM2_b=0,PWM1_b=0,PWM0_b=0,CLKDIS=1,CLKOSEL=0 */
  setReg16(SIM_CLKOUT, 0x20U);         /* Set up the SIM clock output select register */ 
  /* Common initialization of the CPU registers */
  /* SIM_GPSCD: GPS_C12=1,GPS_C8=1 */
  setReg16Bits(SIM_GPSCD, 0x14U);       
  /* GPIO_C_PEREN: PE|=0x1100 */
  setReg16Bits(GPIO_C_PEREN, 0x1100U);  
  /* INTC_IPR3: SCI1_RCV_IPL=2,SCI1_XMIT_IPL=2 */
  clrSetReg16Bits(INTC_IPR3, 0x1040U, 0x2080U); 
  /* ### Init_SCI "SCI1" init code ... */
  SCI1_Init();

  __EI(0);                             /* Enable interrupts of the selected priority level */
}

/* END Cpu. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 3.00 [04.35]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
