



/*  metrowerks sample code  */



/*
	this source illustrates code called by ISR 
	and #pragma directives necessary for ISR-safe code		
*/



#include "MC56F802x3x.h"
#include "led.h"

/* libraries called by interrupt handlers need this pragma, it will:
1. save used register
2. return with RTS instead of RTI */


#pragma interrupt called



void initLED()
{
	/* disable SSI peripheral */       /* factored out for clarity */
	asm(bfclr	#$0800,X:GPIOB_PEREN);  /* LED1 PC0 -- GPIO Port A Bit0 */

	/* output direction */
	asm(bfset	#$0800,X:GPIOB_DDIR);
	
	/* off at first */
	offLED_1();
	
}




/* libraries called by interrupt handlers need this pragma, it will:
1. save used register
2. return with RTS instead of RTI */


#pragma interrupt called

void onLED(int element)
{
	switch (element)
	{
		case 1:
			onLED_1();
			break;
		default:
			asm(debughlt);	/* not a graceful error handling, just freeze */
			break;
	}
}



/* libraries called by interrupt handlers need this pragma, it will:
1. save used register
2. return with RTS instead of RTI */


#pragma interrupt called


void offLED(int element)
{
	switch (element)
	{
		case 1:
			offLED_1();
			break;
		default:
			asm(debughlt);	/* not a graceful error handling, just freeze */
			break;
	}
}




void offLED_1()
{
    asm(bfset #$0800,X:GPIOB_DATA);
}





void onLED_1()
{
    asm(bfclr #$0800,X:GPIOB_DATA);
}









